SystemOrganization addCategory: #'Mars-Core-Base'!
SystemOrganization addCategory: #'Mars-Core-View'!
SystemOrganization addCategory: #'Mars-Core-Layout'!
SystemOrganization addCategory: #'Mars-Core-Announcement'!

Trait named: #TMAnnouncer
	uses: {}
	category: 'Mars-Core-Announcement'!

!TMAnnouncer methodsFor: 'announcing' stamp: 'EstebanLorenzano 2/2/2012 21:20'!
announce: anAnnouncement
	self announcer announce: anAnnouncement! !

!TMAnnouncer methodsFor: 'announcing' stamp: 'EstebanLorenzano 2/2/2012 21:20'!
announcer 
	^self required! !

!TMAnnouncer methodsFor: 'announcing' stamp: 'EstebanLorenzano 2/2/2012 21:20'!
on: anAnnouncement do: aBlock
	self announcer on: anAnnouncement do: aBlock! !

Announcement subclass: #MAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-Announcement'!

MAnnouncement subclass: #MButtonPressed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-Announcement'!

Object subclass: #MLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-Layout'!

MLayout subclass: #MFixedLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-Layout'!

!MFixedLayout methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/3/2012 00:49'!
applyLayout: aContainer
	self flag: #todo.! !

!MLayout methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/3/2012 00:49'!
applyLayout: aContainer
	self subclassResponsibility! !

MLayout subclass: #MVerticalLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-Layout'!

!MVerticalLayout methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/3/2012 00:52'!
applyLayout: aContainer
	| y w h |
	
	w := aContainer width.
	h := (aContainer height / aContainer children size) truncated.
	y := 0.
	
	aContainer children do: [ :each | 
		each bounds: (0@y extent: w@h).
		y := y + h ]! !

Object subclass: #MToolkit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-Base'!

!MToolkit class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/2/2012 21:14'!
classFor: aClass
	^self subclassResponsibility! !

!MToolkit class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/2/2012 21:11'!
current
	^self allSubclasses 
		detect: #isActive
		ifNone: [ self error: 'No platform specific widget' ]! !

!MToolkit class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/2/2012 21:13'!
isActive
	^false! !

Object subclass: #MView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-View'!

MView subclass: #MContainer
	instanceVariableNames: 'clhildren'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-View'!

!MContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:05'!
with: anObject 
	^self platformClass with: anObject! !

!MContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:06'!
with: firstObject with: secondObject
	^self platformClass 
		with: firstObject 
		with: secondObject
 
! !

!MContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:06'!
with: firstObject with: secondObject with: thirdObject
	^self platformClass 
		with: firstObject 
		with: secondObject 
		with: thirdObject 
 
! !

!MContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:06'!
with: firstObject with: secondObject with: thirdObject with: fourthObject
	^self platformClass 
		with: firstObject 
		with: secondObject 
		with: thirdObject 
		with: fourthObject 
! !

!MContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:06'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject 
	^self platformClass 
		with: firstObject 
		with: secondObject 
		with: thirdObject 
		with: fourthObject 
		with: fifthObject! !

!MContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:06'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject with: sixthObject
	^self platformClass 
		with: firstObject 
		with: secondObject 
		with: thirdObject 
		with: fourthObject 
		with: fifthObject 
		with: sixthObject! !

!MContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:07'!
withAll: aCollection
	^self platformClass withAll:  aCollection
! !

MContainer subclass: #MScroller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-View'!

MContainer subclass: #MSplitter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-View'!

MContainer subclass: #MWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-View'!

!MView class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/2/2012 21:08'!
new 
	^self platformClass new! !

!MView class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/2/2012 21:22'!
platformClass 
	^self toolkit classFor: self! !

!MView class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/2/2012 21:22'!
toolkit 
	^MToolkit current! !

MView subclass: #MWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-View'!

MWidget subclass: #MButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-View'!

MWidget subclass: #MList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-View'!

MWidget subclass: #MTextArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Core-View'!
